/* VERSION 2.00 */
/*  20.09.2012  */

#include "stm32_GPIO.h"
#include "stm32f10x_gpio.h"

#define STM32_BitBang

void PIN_ON(GPIO_TypeDef * GPIOx,u16 PINx)
{
	#ifdef STM32_BitBang
		GPIOx->BSRR=PINx;
	#else
		GPIOx->ODR=GPIOx->IDR|(PINx);
	#endif
}

void PIN_OFF(GPIO_TypeDef * GPIOx,u16 PINx)								
{
	#ifdef STM32_BitBang
		GPIOx->BRR=PINx;
	#else
		GPIOx->ODR=GPIOx->IDR&(~(PINx));
	#endif
}

u8 PIN_SYG(GPIO_TypeDef * GPIOx, u16 PINx)
{
	return GPIOx->IDR&PINx;
}

void PIN_INV(GPIO_TypeDef * GPIOx, u16 PINx)
{
	if(PIN_SYG(GPIOx, PINx)!=0)
	{PIN_OFF(GPIOx, PINx);}
	else
	{PIN_ON(GPIOx, PINx);}
}

void PIN_IN (GPIO_TypeDef * GPIOx,u16 PINx)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	GPIO_InitStruct.GPIO_Pin=PINx;
	GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_InitStruct.GPIO_Mode=GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOx, &GPIO_InitStruct);
}

void PIN_OUT_PP (GPIO_TypeDef * GPIOx,u16 PINx)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	GPIO_InitStruct.GPIO_Pin=PINx;
	GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_InitStruct.GPIO_Mode=GPIO_Mode_Out_PP;
	GPIO_Init(GPIOx, &GPIO_InitStruct);
}

void PIN_OUT_OD (GPIO_TypeDef * GPIOx,u16 PINx)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	GPIO_InitStruct.GPIO_Pin=PINx;
	GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_InitStruct.GPIO_Mode=GPIO_Mode_Out_OD;
	GPIO_Init(GPIOx, &GPIO_InitStruct);
}



void PIN_IN_PU (GPIO_TypeDef * GPIOx,u16 PINx)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	GPIO_InitStruct.GPIO_Pin=PINx;
	GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_InitStruct.GPIO_Mode=GPIO_Mode_IPU;
	GPIO_Init(GPIOx, &GPIO_InitStruct);	
	GPIOx->BSRR=PINx;	//Pull-up turn on
}

