#include "spi.h"
#include "main.h"
							
void SPI_init_all (SPI_TypeDef* SPIx)
{
	init_RCC(SPIx);
	init_GPIO(SPIx);
	init_SPI(SPIx);
}

void init_RCC (SPI_TypeDef* SPIx)
{
	if (SPIx==SPI1)
		{
			RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1,ENABLE);
			RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
		}
	if (SPIx==SPI2)
		{
			RCC_APB2PeriphClockCmd(RCC_APB1Periph_SPI2,ENABLE);
			RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
		}
	if (SPIx==SPI3){RCC_APB2PeriphClockCmd(RCC_APB1Periph_SPI3,ENABLE);}
}

void init_GPIO(SPI_TypeDef* SPIx)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	if (SPIx==SPI1)
	{
		GPIO_InitStruct.GPIO_Pin=GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7;		 //alternative func for SPI
		GPIO_InitStruct.GPIO_Mode=GPIO_Mode_AF_PP;
		GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
		GPIO_Init(GPIOA, &GPIO_InitStruct);
		
		PIN_OUT_PP(RF_CE_PIN);
		PIN_OUT_PP(RF_CSN_PIN);
		PIN_IN(RF_IRQ_PIN);		
	}
	if (SPIx==SPI2)
	{
		GPIO_InitStruct.GPIO_Pin=GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15;	 //alternative func for SPI
		GPIO_InitStruct.GPIO_Mode=GPIO_Mode_AF_PP;
		GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
		GPIO_Init(GPIOB, &GPIO_InitStruct);
	}
}

void init_SPI	(SPI_TypeDef* SPIx)
{
	SPI_InitTypeDef SPI_InitStruct;
	SPI_InitStruct.SPI_Direction=SPI_Direction_2Lines_FullDuplex;
	SPI_InitStruct.SPI_Mode=SPI_Mode_Master;
	SPI_InitStruct.SPI_DataSize=SPI_DataSize_8b;
	SPI_InitStruct.SPI_CPOL=SPI_CPOL_Low;
	SPI_InitStruct.SPI_CPHA=SPI_CPHA_1Edge;
	SPI_InitStruct.SPI_NSS=SPI_NSS_Soft;
	SPI_InitStruct.SPI_BaudRatePrescaler=SPI_BaudRatePrescaler_2;
	SPI_InitStruct.SPI_FirstBit=SPI_FirstBit_MSB;
	SPI_InitStruct.SPI_CRCPolynomial=7;
	SPI_Init(SPIx, &SPI_InitStruct);

	SPI_Cmd(SPIx, ENABLE);
}

void SPI_SendByte(SPI_TypeDef* SPIx,u8 byte)
{
	u8 tmp=SPI_ReadByte(SPIx,byte);	
}

u8 SPI_ReadByte(SPI_TypeDef* SPIx,u8 byte)
{
	#ifdef test_spi
		test_var=byte;
	#endif
    /* Loop while DR register in not emplty */
  while (SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_TXE) == RESET);

  /* Send byte through the SPI1 peripheral */
  SPI_I2S_SendData(SPIx, byte);

  /* Wait to receive a byte */
  while (SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_RXNE) == RESET);

  /* Return the byte read from the SPI bus */
  return SPI_I2S_ReceiveData(SPIx);
}


